function [z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(z,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag)
%
%
%'%%%%%%%%% function Metropolis_post %%%%%%%%%%%%%%%%%'

rng(98765);
'inside Metropolis_post no seed'

dim=length(z);
itb=0;
iter_bestvalue=0;

for iter=1:max_iter
    if iter-1 == floor((iter-1)/25)*25
        iter
    end
    
    e=uniform_direction(dim);
    y=z+e*stepsize*step_factor;
    [fy,~,~,~,costcall,costflag]=cost(y,Z,X,z0,ZbC,costcall,costflag);
    if(costflag==0)
        r=(fz-fy)/posttemperature;
        accept=(r>0.0);
        if accept==0
            %'good'
            accept=(unifrnd(0,1)<exp(r))*1;
        end
        if(accept==1)
            %'boooooooooooom'
            fz=fy;
            z=y;
        end
        if accept==1 && fy<bestvalue
            bestvalue=fy;
            bestx=y;
            iter_bestvalue=iter;
            itb=itb+1;
        end
    else
        iter=iter-1;
    end
end
it_best_num=itb;

% auxF=unifrnd(0,1);
% auxF
end
