function condMean=conditionalMean(b,Z,X,z0,ZbC)

[nL,nSubj]=size(Z);
dM=2*nL-4; %dM is the dimension (over R) of the planar shape space.
dimC=nL-2;

[nSubj1,cov_num]=size(X);
if nSubj ~= nSubj1 
    error('covariates X and responses Y (i.e. Z) are not provided for the same number of subjects');
end
if length(z0) ~= nL || abs(mean(z0))>0.0000000001 || abs(norm(z0)-1)>0.0000000001
    error('z0 and Z are not in the same manifold');
end

% adjust the cost value
costfactor=10000;

nb=length(b);
if mod(nb,dM) ~= 0
    error('length of b is must be a multiple of dM');
end

condMean=zeros(nL,nSubj); 

bC=reshape(b,2,[]).'*[1;1i];
Baug=reshape(bC,dimC,[]);
bq=Baug(:,1);

csi_bq=ZbC*bq;
zq=exp2DshapeC(z0,csi_bq);

if length(bC)==dimC
    for subj=1:nSubj
        condMean(:,subj)=zq;
    end
else
    B=Baug;
    B(:,1)=[];
    [rB,cB]=size(B);
    if cB ~= cov_num
        error('matrix B, of covariate parameters, and matrix X must have the same number of columns');
    end
    BX=B*(X.');
    [ZbC_zq,U]=spUnitaryGeodesic2DshapeC(z0,zq,ZbC);
    csi_BX=ZbC_zq*BX; % csi_BX is a dimC x nSubj matrix
                              % each column is a tangent vector at z
    for subj=1:nSubj
        mux=exp2DshapeC(zq,csi_BX(:,subj));
        condMean(:,subj)=mux;
    end
end

end