function yprime=db1_dExp1(b,z0,ZbC,xcov)
% Derivative (Jacobian) matrix of b1-->exp2DshapeC(z0,ZbC*Bxcov)

b=b(:);
nb=length(b);
ncov=length(xcov);
[nL,dimC]=size(ZbC);
dM=2*dimC;

if nb ~= dM*ncov
    error('In db1_dExp1(): b has not the corect length');
end

bC=reshape(b,2,[]).'*[1;1i];
B=reshape(bC,dimC,[]);
Bxcov=B*(xcov(:));
y=exp2DshapeC(z0,ZbC*Bxcov); %%% can be used as an addittional output

yprime=zeros(nL,length(b));
if norm(Bxcov) ~= 0
    yp=(-sin(norm(Bxcov))*z0+msin_prime(norm(Bxcov))*(ZbC*Bxcov)); %% nL x 1 vector;
    aux=reshape([real(Bxcov),imag(Bxcov)].',dM,1); %% dM x 1 vector
    aux=aux*xcov; %% dM x ncov matrix
    aux=reshape(aux,1,nb); %% 1 x length(b) vector; length(b)=nb=dM*ncov;
    yprime=yp*aux/norm(Bxcov);  %% nL x length(b) matrix
end
tmp=repmat(xcov,dimC,1); %% dimC x ncov matrix
mZbC=repmat(ZbC,1,ncov)*diag(tmp(:));  %% nL x (dimC*ncov) = nL x length(b) matrix
yprime=yprime+msin(norm(Bxcov))*reshape([mZbC;1i*mZbC],nL,[]);
end