function [rotResid,rotResid_prime]=db_Log_z0star_sp(z0,mu,db_dmu,z)
    %%% This function calculates the rotated residual and its Jacobian
    %%% matrix, given the response z, conditional mean mu, and the base
    %%% point z0. !!!!! It works fo a sunbject at a time!!!!!
    %%% - mu is the conditional mean;
    %%% - the regression parameters b and and the
    %%%   covariates xcov are conatined insiade of mu;
    %%% - mu and the Jacobian matrix, db_dmu, of mu must be povided.

size(db_dmu)
size(z)
tz=z'*mu;
atz=abs(tz);
db_datz=(real(z'*db_dmu)*conj(tz))/(atz^2);
db_dzethetaSTARmu=1/atz*(z'*db_dmu)-real((z'*db_dmu)*conj(tz))/atz^4;

tz0=z0'*mu;
atz0=abs(tz0);
db_datz0=(real(z0'*db_dmu)*conj(tz0))/(atz0^2);
db_dz0ethetaSTARmu=1/atz0*(z0'*db_dmu)-real((z0'*db_dmu)*conj(atz0))/atz0^4;

zSTARmu=tz/abs(tz)*z;
db_dzSTARmu=z*db_dzethetaSTARmu;

z0STARmu=tz0/abs(tz0)*z0;
db_dz0STARmu=z0*db_dz0ethetaSTARmu;

%%% Derivative of partially rotated residual
%%% Partially rotated residual 
%%% sp(mu,z0,Log(mu,z))=Log(z0STARmu,sp(mu,z0,z))=fac*vterm,
%%% where
%%% fac=macos(atz), vterm=sp(mu,z0,zSTARmu)-atz*z0STARmu; mu depends on b;
%%% [rotResid,rotResid_prime=db_dLog(mu,z0,z);
resid=log2DshapeCvec(mu,z); %% resid at mu
pRotResid=spUnitaryGeodesic2DshapeC(mu,z0,resid); %% rotated resid at z0STARmu
rotResid=(conj(tz0)/atz0)*pRotResid; %% rotated resid at z0

%%% BEGIN Derivarives
fac=macos(atz);
db_dfac=macos_prime(atz)*db_datz;

vterm_1=spUnitaryGeodesic2DshapeC(mu,z0,zSTARmu);
vterm_2=abs(tz)*z0STARmu;
vterm=vterm_1-vterm_2;

vterm_1zSTARmu=zSTARmu;
db_dvterm_1zSTARmu=db_dzSTARmu;
g1=1/(1+atz0);
db_dg1=-(1+atz0)^2*db_datz0;
scprod_zSTARmu_z0STARmu=z0STARmu'*zSTARmu;
db_dscprod_zSTARmu_z0STARmu=z0STARmu'*db_dzSTARmu+conj(zSTARmu'*db_dz0STARmu);
tmp=g1*(scprod_zSTARmu_z0STARmu+atz);
db_dtmp=(scprod_zSTARmu_z0STARmu+atz)*db_dg1 + g1*(db_dscprod_zSTARmu_z0STARmu+db_datz);
vterm_1mu=-tmp*mu;
db_dvterm_1mu=-mu*db_dtmp - tmp*db_dmu;
vterm_1z0STARmu=(2*atz-tmp)*z0STARmu;
db_dvterm_1z0STARmu=z0STARmu*(2*db_datz-db_dtmp)+(2*atz-tmp)*db_dz0STARmu;
db_dvterm_1=db_dvterm_1zSTARmu+db_dvterm_1mu+db_dvterm_1z0STARmu;

db_dvterm_2=z0STARmu*db_datz+atz*db_dz0STARmu;

db_dvterm=db_dvterm_1-db_dvterm_2;

pRotResid_prime=vterm*db_dfac+fac*db_dvterm;
rotResid_prime=(conj(tz0)/atz0)*pRotResid_prime+pRotResid*conj(db_dz0ethetaSTARmu);

end





