function [mu,db_dmu]=db_dCondMean(b,z0,ZbC,xcov)
% Derivative (Jacobian) matrix of b-->conditionalMean(b,Z,X,z0,ZbC)
%

[nL,dimC]=size(ZbC);
ncov=length(xcov);
dim=length(b);

dM=2*dimC;

if dim~=dM*(1+ncov)
    error('Error in db_dCondMean(): the length of beta is not correct!');
end

b0=b(1:dM);
b1=b((dM+1):dim);
b0C=reshape(b0,2,[]).'*[1;1i];
b1C=reshape(b1,2,[]).'*[1;1i];
B=reshape(b1C,dimC,[]);
Bxcov=B*xcov(:);

Bxcov_norm=norm(Bxcov);
zq=exp2DshapeC(z0,ZbC*b0C);
ZbC_zq=spUnitaryGeodesic2DshapeC(z0,zq,ZbC);
mu=exp2DshapeC(zq,ZbC_zq*Bxcov);

db0_dmu=cos(Bxcov_norm)*db0_dExp0(b0,z0,ZbC)+ ...
    msin(Bxcov_norm)*db0_dsp_z0_zqBeta0(b0,z0,ZbC,ZbC*Bxcov); %% nL x dM matrix
db1_dmu=db1_dExp1(b1,zq,ZbC_zq,xcov);  %% nL x dM*ncov
db_dmu=[db0_dmu db1_dmu];   %% nL x dM*(1+ncov) = nL x length(b) matrix; b=(b0,b1);
end




