function [rotResid,rotResid_prime]=db_drotResid(z0,mu,db_dmu,z)
    %%% This function calculates the rotated residual and its Jacobian
    %%% matrix, given the response z, conditional mean mu, and the base
    %%% point z0. !!!!! It works fo a sunbject at a time!!!!!
    %%% - mu is the conditional mean;
    %%% - the regression parameters b and and the
    %%%   covariates xcov are conatined insiade of mu;
    %%% - mu and the Jacobian matrix, db_dmu, of mu must be povided.

%size(db_dmu)
%size(z)
tz=z'*mu;
atz=abs(tz);
zethetaSTARmu=tz/atz;
zSTARmu=zethetaSTARmu*z;
db_dtz=z'*db_dmu;
db_datz=real(db_dtz*conj(tz))/atz;
db_dzethetaSTARmu=(1/atz)*db_dtz-(tz/atz^2)*db_datz;
db_dzSTARmu=z*db_dzethetaSTARmu;

tz0=z0'*mu;
atz0=abs(tz0);
z0ethetaSTARmu=tz0/atz0;
z0STARmu=z0ethetaSTARmu*z0;
db_dtz0=z0'*db_dmu;
db_datz0=real(db_dtz0*conj(tz0))/atz0;
db_dz0ethetaSTARmu=(1/atz0)*db_dtz0-(tz0/atz0^2)*db_datz0;
db_dz0STARmu=z0*db_dz0ethetaSTARmu;

%%% Derivative of partially rotated residual
%%% Partially rotated residual 
%%% sp(mu,z0,Log(mu,z))=Log(z0STARmu,sp(mu,z0,z))=fac*vterm,
%%% where
%%% fac=macos(atz), vterm=sp(mu,z0,zSTARmu)-atz*z0STARmu; mu depends on b;
%%% [rotResid,rotResid_prime=db_dLog(mu,z0,z);
Aresid=log2DshapeCvec(mu,z); %% resid at mu
ApRotResid=spUnitaryGeodesic2DshapeC(mu,z0,Aresid); %% rotated resid at z0STARmu
ArotResid=(conj(tz0)/atz0)*ApRotResid; %% rotated resid at z0

%%% BEGIN Derivarives
fac=macos(atz);
db_dfac=macos_prime(atz)*db_datz;

%%% auxPRotResid is calculated just for checking some results;
BpRotResid=log2DshapeCvec(z0STARmu,spUnitaryGeodesic2DshapeC(mu,z0,z));
BrotResid=(conj(tz0)/atz0)*BpRotResid;


vterm_1=spUnitaryGeodesic2DshapeC(mu,z0,zSTARmu);
vterm_2=atz*z0STARmu;
vterm=vterm_1-vterm_2;
%%% vterm1 is a sum of three terms: one for zSTARmu, one for mu, and one
%%% for z0STARmu
% 1) term for zSTARmu
vterm_1zSTARmu=zSTARmu;
db_dvterm_1zSTARmu=db_dzSTARmu;
% 2) term for mu
scprod_zSTARmu_z0STARmu=z0STARmu'*zSTARmu;
g1=1/(1+atz0);
tmp=g1*(scprod_zSTARmu_z0STARmu+atz);
vterm_1mu=-tmp*mu;
db_dscprod_zSTARmu_z0STARmu=z0STARmu'*db_dzSTARmu+conj(zSTARmu'*db_dz0STARmu);
db_dg1=-(1+atz0)^(-2)*db_datz0;
db_dtmp=(scprod_zSTARmu_z0STARmu+atz)*db_dg1 + g1*(db_dscprod_zSTARmu_z0STARmu+db_datz);
db_dvterm_1mu=-mu*db_dtmp - tmp*db_dmu;
% term for z0STARmu
vterm_1z0STARmu=(2*atz-tmp)*z0STARmu;
db_dvterm_1z0STARmu=z0STARmu*(2*db_datz-db_dtmp)+(2*atz-tmp)*db_dz0STARmu;
% entire term:  vterm_1
db_dvterm_1=db_dvterm_1zSTARmu+db_dvterm_1mu+db_dvterm_1z0STARmu;

%%% Not needed auxVterm_1, but used for checking some results;
%auxVterm_1=vterm_1zSTARmu+vterm_1mu+vterm_1z0STARmu;
%max(abs(auxVterm_1-vterm_1))

db_dvterm_2=z0STARmu*db_datz+atz*db_dz0STARmu;
db_dvterm=db_dvterm_1-db_dvterm_2;

pRotResid=fac*vterm;
rotResid=conj(z0ethetaSTARmu)*pRotResid;
pRotResid_prime=vterm*db_dfac+fac*db_dvterm;
rotResid_prime=conj(z0ethetaSTARmu)*pRotResid_prime+pRotResid*conj(db_dz0ethetaSTARmu);
end





