% FIRST run f0001_ADNI_Data.m

betalength=pi/2;   % 1.0;

dimrange=zeros(dim,2);
dimrange(:,1)=-betalength;
dimrange(:,2)=betalength;

% set the population = 50 or 100;
population=50;   %100;

fvalue=zeros(population,1);
x=zeros(population,dim);

rng(12345);
costcall=0;

j=0;
for G=1:population
    costflag=100;
    while costflag ~= 0
        j=j+1;
        b=unifrnd(dimrange(:,1),dimrange(:,2));
        [bq,BX]=betaR2tanVecsComps(b,dimC,X);
        r1=norm(bq);
        if r1 >= pi/2
            r=unifrnd(0,1)*pi/2;
            b(1:dM)=(r/r1)*b(1:dM);
        end
        r2=sqrt(max(sum(abs(BX).^2)));
        if r2 >= pi/2
            r=unifrnd(0,1)*pi/2;
            b((dM+1):dim)=(r/r2)*b((dM+1):dim);
        end      

        [c,condMean,resid,rotResid,costcall,costflag]=cost(b,Z,X,z0,ZbC,costcall,costflag);
    end
    fz=c;
    x(G,:)=b;
    fvalue(G)=c;     
end
'after x(:,:) is generated'

bestvalue=min(fvalue);
Gmin=find(fvalue==bestvalue,1,'first');
bestx=x(Gmin,:);

orig_bestvalue=bestvalue;
orig_bestvalue
orig_Gmin=Gmin;
orig_bestx=bestx;

save('wks01_ORIG_20140426GAD_ADSt1');

%%%%%%%%%%%%%%%%%
% rng(123456);

lowE=-10.0;
maxEE=2000000;
scale=5.0;  %5.0;
range=50.0;

%%%%%%% Parameters for annealing algorithm %%%%
if model==3 || model==6 || model==8
    total_iteration=30000;  %100000;
    total_iteration

    rho=1.0;
    tau=1.0;

    temperature=50; %50;
    stepsize=0.0001;
    stepscale=25;  %2000
    WARM=1;

    seltem=1;  % 1000;
    delta=1.0;

    %%%%%%% Parameters for Metropolis_post algorithm %%%%

    max_iter=1000;
    max_iter
    posttemperature=0.1; %0.05
    step_factor=0.5; %0.01
end

accept_cross=0;
total_cross=0;
accept_loc=0;
total_loc=0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
maxE=maxEE;
grid=ceil((maxEE+2*range-lowE)*scale);
sze=floor((maxE+range-lowE)*scale);

refden=ones(1,grid+1)/(grid+1);
hist=zeros(grid+1,3);
hist(:,1)=lowE+(0:grid)/scale;

maxE=sum(fvalue);
if maxE>maxEE
    error('The choice of maxEE is too small, the program has to exit.');
end
accept_loc=0.1; total_loc=accept_loc;
accept_cross=0.1; total_cross=accept_cross;
costcall=0;
iter=0;

while costcall <= total_iteration
    iter=iter+1;
    start_costcall=costcall;
    start_costcall
    if iter<=WARM*stepscale
        delta=rho;
    else
        delta=rho*exp(-tau*log((iter-(WARM-1)*stepscale)/stepscale));
    end
    un=unifrnd(0,1);
    
   if un<0.05
       [x,fvalue,hist,bestvalue,bestx,accept_loc,total_loc,maxE,costcall,costflag]=...
           metmove(x,fvalue,bestvalue,bestx,hist,refden,accept_loc,total_loc,...
           maxE,lowE,range,scale,stepsize,delta,temperature,Z,X,z0,ZbC,costcall,costflag);
   elseif un<0.1
       [x,fvalue,hist,bestvalue,bestx,accept_loc,total_loc,maxE,costcall,costflag]=...
           metmove2(x,fvalue,bestvalue,bestx,hist,refden,accept_loc,total_loc,...
           maxE,lowE,range,scale,stepsize,delta,temperature,Z,X,z0,ZbC,costcall,costflag);
   elseif un<0.4
       [x,fvalue,hist,bestvalue,bestx,accept_cross,total_cross,maxE,costcall,costflag]=...
           crossmove3(x,fvalue,bestvalue,bestx,hist,refden,accept_cross,total_cross,...
           maxE,lowE,range,scale,delta,temperature,seltem,Z,X,z0,ZbC,costcall,costflag);
   elseif un<0.7
       [x,fvalue,hist,bestvalue,bestx,accept_cross,total_cross,maxE,costcall,costflag]=...
           crossmove4(x,fvalue,bestvalue,bestx,hist,refden,accept_cross,total_cross,...
           maxE,lowE,range,scale,delta,temperature,seltem,Z,X,z0,ZbC,costcall,costflag);
   else
       [x,fvalue,hist,bestvalue,bestx,accept_cross,total_cross,maxE,costcall,costflag]=...
           crossmove5(x,fvalue,bestvalue,bestx,hist,refden,accept_cross,total_cross,...
           maxE,lowE,range,scale,delta,temperature,seltem,Z,X,z0,ZbC,costcall,costflag);

   end
end

am_bestvalue=bestvalue;
am_bestx=bestx;
am_bestvalue
am_bestx;

tmp= find(hist(1:sze,3)<=0.0);
if isempty(tmp)==0
    ave=mean(refden(tmp));
else
    ave=0;
end
hist(1:sze,2)=hist(1:sze,2)+log(refden(1:sze)'+ave);
maxh2=max(hist(1:sze,2));
hist(1:sze,2)=hist(1:sze,2)-maxh2;
s=sum(exp(hist(1:sze,2)));
hist(1:sze,2)=hist(1:sze,2)-log(s)+log(100.0);
hist(1:sze,3)=0.0;
fz=bestvalue;
bestz=bestx;

save('wks02a_AM_20140426GAD_ADSt1');


'enter Metropolis_plus 1'
fz=am_bestvalue;
bestz=am_bestx;
bestvalue=am_bestvalue;
bestx=am_bestx;

costcall=0;
max_iter=10000;
stepsize=1;
step_factor=0.001;
posttemperature=0.001;
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);
m1_max_iter=max_iter;
m1_it_best_num=it_best_num;
m1_iter_bestvalue=iter_bestvalue;
m1_bestvalue=bestvalue;
m1_bestx=bestx;
m1_max_iter
m1_it_best_num
m1_iter_bestvalue
m1_bestvalue
m1_bestx;
save('wks03_M1_20140426GAD_ADSt1');

'enter Metropolis_plus 2'
bestz=m1_bestx;
fz=m1_bestvalue
bestvalue=m1_bestvalue;

max_iter=10000;
stepsize=1;
step_factor=0.0001;
posttemperature=0.0001;
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);

m2_max_iter=max_iter;
m2_it_best_num=it_best_num
m2_iter_bestvalue=iter_bestvalue;;
m2_bestvalue=bestvalue;
m2_bestx=bestx;
m2_max_iter
m2_it_best_num
m2_iter_bestvalue
m2_bestvalue
m2_bestx;
save('wks04_M2_20140426GAD_ADSt1');

'enter Metropolis_plus 3'
bestz=m2_bestx;
fz=m2_bestvalue
bestvalue=m2_bestvalue;

max_iter=20000;
stepsize=1;
step_factor=10^(-4);
posttemperature=10^(-5);  %0.01;
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);

m3_max_iter=max_iter;
m3_it_best_num=it_best_num;
m3_iter_bestvalue=iter_bestvalue;
m3_bestvalue=bestvalue;
m3_bestx=bestx;
m3_max_iter
m3_it_best_num
m3_iter_bestvalue
m3_bestvalue
m3_bestx;
save('wks05_M3_20140426GAD_ADSt1');

'enter Metropolis_plus 4'
bestz=m3_bestx;
fz=m3_bestvalue
bestvalue=m3_bestvalue;

max_iter=20000;
stepsize=1;
step_factor=5*10^(-5);
posttemperature=1*10^(-6); 
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);

m4_max_iter=max_iter;
m4_it_best_num=it_best_num;
m4_iter_bestvalue=iter_bestvalue;;
m4_bestvalue=bestvalue;
m4_bestx=bestx;
m4_max_iter
m4_it_best_num
m4_iter_bestvalue
m4_bestvalue
m4_bestx;
save('wks06_M4_20140426GAD_ADSt1');

'enter Metropolis_plus 5'
bestz=m4_bestx;
fz=m4_bestvalue
bestvalue=m4_bestvalue;

max_iter=20000;
stepsize=1;
step_factor=10^(-5);
posttemperature=1*10^(-8);  %0.01;
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);

m5_max_iter=max_iter;
m5_it_best_num=it_best_num;
m5_iter_bestvalue=iter_bestvalue;;
m5_bestvalue=bestvalue;
m5_bestx=bestx;
m5_max_iter
m5_it_best_num
m5_iter_bestvalue
m5_bestvalue
m5_bestx;
save('wks07_M5_20140426GAD_ADSt1')

'enter Metropolis_plus 6'
bestz=m5_bestx;
fz=m5_bestvalue
bestvalue=m5_bestvalue;

max_iter=20000;
stepsize=1;
step_factor=5*10^(-6);
posttemperature=1*10^(-9);  %0.01;
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);

m6_max_iter=max_iter;
m6_it_best_num=it_best_num;
m6_iter_bestvalue=iter_bestvalue;
m6_bestvalue=bestvalue;
m6_bestx=bestx;
m6_max_iter
m6_it_best_num
m6_iter_bestvalue
m6_bestvalue
m6_bestx;
save('wks08_M6_20140426GAD_ADSt1');

'enter Metropolis_plus 7'
bestz=m6_bestx;
fz=m6_bestvalue
bestvalue=m6_bestvalue;

max_iter=20000;
stepsize=1;
step_factor=1*10^(-6);
posttemperature=1*10^(-9);  %0.01;
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);

m7_max_iter=max_iter;
m7_it_best_num=it_best_num;
m7_iter_bestvalue=iter_bestvalue;
m7_bestvalue=bestvalue;
m7_bestx=bestx;
m7_max_iter
m7_it_best_num
m7_iter_bestvalue
m7_bestvalue 
m7_bestx;
save('wks09_M7_20140426GAD_ADSt1');

'enter Metropolis_plus 8'
bestz=m7_bestx;
fz=m7_bestvalue
bestvalue=m7_bestvalue;

max_iter=20000;
stepsize=1;
step_factor=5*10^(-7);
posttemperature=1*10^(-10);
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);

m8_max_iter=max_iter;
m8_it_best_num=it_best_num;
m8_iter_bestvalue=iter_bestvalue;
m8_bestvalue=bestvalue;
m8_bestx=bestx;
m8_max_iter
m8_it_best_num
m8_iter_bestvalue
m8_bestvalue
m8_bestx;
save('wks10_M8_20140426GAD_ADSt1');

'enter Metropolis_plus 9'
bestz=m8_bestx;
fz=m8_bestvalue
bestvalue=m8_bestvalue;

max_iter=20000;
stepsize=1;
step_factor=5*10^(-8);
posttemperature=10^(-11);  %0.01;
[z,fz,bestvalue,bestx,iter_bestvalue,it_best_num,costcall,costflag]=...
    Metropolis_post(bestz,fz,bestvalue,bestx,max_iter,step_factor,stepsize,...
    posttemperature,Z,X,z0,ZbC,costcall,costflag);

m9_max_iter=max_iter;
m9_it_best_num=it_best_num;
m9_iter_bestvalue=iter_bestvalue;
m9_bestvalue=bestvalue;
m9_bestx=bestx;
m9_max_iter
m9_it_best_num
m9_iter_bestvalue
m9_bestvalue
m9_bestx;
save('wks11_M9_20140426GAD_ADSt1');

% Estimates of beta from Stage 1 %
bEstI=m9_bestx;
[c,condMean,resid,rotResid,costcall,costflag]=cost(bEstI,Z,X,z0,ZbC,costcall,costflag);

resultsValues=zeros(12,1);
resultsMaxIter=[m1_max_iter; m2_max_iter; m3_max_iter; m4_max_iter;...
    m5_max_iter; m6_max_iter; m7_max_iter; m8_max_iter; m9_max_iter];
resultsIterBestNum=zeros(9,1);
resultsIterBestvalue=zeros(9,1);
resultsBeta=[m1_bestx; m2_bestx; m3_bestx; m4_bestx; m5_bestx; m6_bestx;...
    m7_bestx; m8_bestx; m9_bestx];

resultsValues(1)=costI_exp_vZ_mean/costfactor;
resultsValues(2)=orig_bestvalue/costfactor;
resultsValues(3)=am_bestvalue/costfactor;
resultsValues(4)=m1_bestvalue/costfactor;
resultsValues(5)=m2_bestvalue/costfactor;
resultsValues(6)=m3_bestvalue/costfactor;
resultsValues(7)=m4_bestvalue/costfactor;
resultsValues(8)=m5_bestvalue/costfactor;
resultsValues(9)=m6_bestvalue/costfactor;
resultsValues(10)=m7_bestvalue/costfactor;
resultsValues(11)=m8_bestvalue/costfactor;
resultsValues(12)=m9_bestvalue/costfactor;
%%% 
resultsIterBestvalue(1)=m1_iter_bestvalue;
resultsIterBestvalue(2)=m2_iter_bestvalue;
resultsIterBestvalue(3)=m3_iter_bestvalue;
resultsIterBestvalue(4)=m4_iter_bestvalue;
resultsIterBestvalue(5)=m5_iter_bestvalue;
resultsIterBestvalue(6)=m6_iter_bestvalue;
resultsIterBestvalue(7)=m7_iter_bestvalue;
resultsIterBestvalue(8)=m8_iter_bestvalue;
resultsIterBestvalue(9)=m9_iter_bestvalue;
%%%
resultsIterBestNum(1)=m1_it_best_num;
resultsIterBestNum(2)=m2_it_best_num;
resultsIterBestNum(3)=m3_it_best_num;
resultsIterBestNum(4)=m4_it_best_num;
resultsIterBestNum(5)=m5_it_best_num;
resultsIterBestNum(6)=m6_it_best_num;
resultsIterBestNum(7)=m7_it_best_num;
resultsIterBestNum(8)=m8_it_best_num;
resultsIterBestNum(9)=m9_it_best_num;

save('wks12_Final_M9_EndEstimSt1_20140426GAD_ADSt1');

