%%% Run 
%%% 1. setData.m, 
%%% 2. mainEstimStage1.m, 
%%% bEstI is defined in mainEstimStage1.m

[nL,nSubj]=size(Z);
[nL,dimC]=size(ZbC);
dM=2*dimC;

bEstI=m9_bestx; %the Stage I estimate of beta from mainEstimStage1.m
b=bEstI;
dim=length(b);

cmuICmat=zeros(nL,nSubj);
db_dcmuICmat=zeros(nL,dim,nSubj);
rotResidICmat=zeros(nL,nSubj);
db_drotResidICmat=zeros(nL,dim,nSubj);
compRotResidIC=zeros(dimC,nSubj);
db_dcompRotResidIC=zeros(dimC,dim,nSubj);

for subj=1:nSubj
    [cmuICmat(:,subj),db_dcmuICmat(:,:,subj)]=db_dCondMean(bEstI,z0,ZbC,X(subj,:));
    [rotResidICmat(:,subj),db_drotResidICmat(:,:,subj)]=db_drotResid(z0,cmuICmat(:,subj),db_dcmuICmat(:,:,subj),Z(:,subj));
end

compRotResidIC=ZbC'*rotResidICmat;
db_dcompRotResidIC=zeros(dimC,dim,nSubj);

for subj=1:nSubj
    db_dcompRotResidIC(:,:,subj)=ZbC'*db_drotResidICmat(:,:,subj);
end

compRotResidIR=zeros(2*dimC,nSubj);
db_dcompRotResidIR=zeros(2*dimC,dim,nSubj);
for j=1:dimC
    compRotResidIR(2*j-1,:)=real(compRotResidIC(j,:));
    compRotResidIR(2*j,:)=imag(compRotResidIC(j,:));
    db_dcompRotResidIR(2*j-1,:,:)=real(db_dcompRotResidIC(j,:,:));
    db_dcompRotResidIR(2*j,:,:)=imag(db_dcompRotResidIC(j,:,:));
end

sideMat=zeros(dim,dim);
dE_E=zeros(dim,nSubj);
dEprime_dE=zeros(2*dimC,dim,nSubj);
for subj=1:nSubj
    dE_E(:,subj)=db_dcompRotResidIR(:,:,subj).'*compRotResidIR(:,subj);
    dEprime_dE(:,:,subj)=db_dcompRotResidIR(:,:,subj);
end
mean_dE_E=mean(dE_E,2);
mean_db_dcompRotResidIR=mean(db_dcompRotResidIR,3);

midMat=zeros(dim,dim);
for subj=1:nSubj
    aux=dE_E(:,subj)-mean_dE_E;
    midMat=midMat+aux*aux.';
    aux2=db_dcompRotResidIR(:,:,subj);
    sideMat=sideMat+aux2.'*aux2;
end
midMat=midMat/nSubj;
sideMat=sideMat/nSubj;
invSideMat=sideMat\eye(dim);

SSSig=invSideMat*midMat*invSideMat.';
SSSig=(SSSig+SSSig.')/2;

SigmaI=SSSig/nSubj;

% Hypotheses testing
aux=zeros(dM,dM);
Cintercept=[eye(dM) aux aux aux aux];
Cgender=[aux eye(dM) aux aux aux];
Cage=[aux aux eye(dM) aux aux];
Cdiagnosis=[aux aux aux eye(dM) aux];
CinterAD=[aux aux aux aux eye(dM)];

SigIintercept=Cintercept*SigmaI*(Cintercept.');
SigIgender=Cgender*SigmaI*(Cgender.');
SigIage=Cage*SigmaI*(Cage.');
SigIdiagnosis=Cdiagnosis*SigmaI*(Cdiagnosis.');
SigIinterAD=CinterAD*SigmaI*(CinterAD.');

b=bEstI.';
WIintercept=(Cintercept*b).'*inv(SigIintercept)*(Cintercept*b);
WIgender=(Cgender*b).'*inv(SigIgender)*(Cgender*b);
WIage=(Cage*b).'*inv(SigIage)*(Cage*b);
WIdiagnosis=(Cdiagnosis*b).'*inv(SigIdiagnosis)*(Cdiagnosis*b);
WIinterAD=(CinterAD*b).'*inv(SigIinterAD)*(CinterAD*b);

pI_intercept=1-chi2cdf(WIintercept,dM)
pI_gender=1-chi2cdf(WIgender,dM)
pI_age=1-chi2cdf(WIage,dM)
pI_diagnosis=1-chi2cdf(WIdiagnosis,dM)
pI_interAD=1-chi2cdf(WIinterAD,dM)

save('wks13_f003_SIGMA_I_20140428GAD_ADSt1');


