%%% Run 
%%% 1. f001_setData.m,
%%% 2. f002_mainStage1.m, then
%%% 3. f003CF_covMatStage1.m;

%%% from f003CF_covMatStage1.m we get:
%%% compRotResidIR a (2*dimC) x nSubj;
%%% db_dcompRotResidIR a 3D-array (2*dimC) x dim x nSubj;

ind_discr=find(cov_type==1);

sc_cov_discr=zeros(size(cov_type));
sc_cov_discr(ind_discr)=cov_type(ind_discr).*(2.^(0:(length(ind_discr)-1)));

scores_cov_discr_ALL=X0*(sc_cov_discr.');
[X0(1:20,:) scores_cov_discr_ALL(1:20)]

%%% bEstI was calculated in mainEstimStage1.m
[c,condMean,resid,rotResid,costcall,costflag]=cost(bEstI,Z,X,z0,ZbC,costcall,costflag);
compRotResid=ZbC'*rotResid;
d_db_compRotResid=zeros(dimC,dim,nSubj);

compRotResidR=zeros(2*dimC,nSubj);
d_db_compRotResidR=zeros(2*dimC,dim,nSubj);
for j=1:dimC
    compRotResidR(2*j-1,:)=real(compRotResid(j,:));
    compRotResidR(2*j,:)=imag(compRotResid(j,:));
    d_db_compRotResidR(2*j-1,:,:)=real(d_db_compRotResid(j,:,:));
    d_db_compRotResidR(2*j,:,:)=imag(d_db_compRotResid(j,:,:));
end

%%% Vhat
Vhat=zeros(dM,dM);
Dhat=zeros(dM,dim,nSubj);
for subj=1:nSubj
    Vhat=Vhat+compRotResidIR(:,subj)*compRotResidIR(:,subj).';
end
Vhat1=Vhat/nSubj;
origVhat1=Vhat1;
invVhat1=inv(Vhat1);

Vhat2=cov(compRotResidIR.');
invVhat2=inv(Vhat2);
invVhat=invVhat2;
mean(compRotResidIR,2);

%%% Dhat and hEhat     
Dhat=zeros(dim,dM,nSubj);
hEhat=zeros(dim,dM,nSubj);
if model==3 % if the model does not contain AGE, only discrete covariates
    scores_unique=unique(scores_cov_discr_ALL);
    scores_unique=(scores_unique(:)).';
    for sc=scores_unique
        ind_subj=find(scores_cov_discr_ALL==sc);
        ind_subj=(ind_subj(:)).';
        Dhat_sc=mean(db_dcompRotResidIR(:,:,ind_subj),3).';
        hEhat_sc=Dhat_sc*invVhat;
        for subj=ind_subj
            Dhat(:,:,subj)=Dhat_sc;
            hEhat(:,:,subj)=hEhat_sc;
        end
    end
elseif model==6 || model==8 % if the model contains the covariate AGE;
    aux=repmat(XX(:,2),1,nSubj);
    d_age=abs(aux-aux.');
    d=d_age;
    d=(d+d.')/2;
    d=d-diag(diag(d));
    
%     L=2;
%     maskL=zeros(nSubj,nSubj);
    kerL=zeros(nSubj,nSubj);
    for subj=1:nSubj
        ind_subj=find(scores_cov_discr_ALL==scores_cov_discr_ALL(subj));
%         [aux,IND]=sort(d(ind_subj,subj));
%         maskL(ind_subj(IND(1:2*L+1)),subj)=1;
%         kerL(ind_subj(IND(1:2*L+1)),subj)=1/(2*L+1);       
        kerL(ind_subj,subj)=exp(-d(ind_subj,subj).*d(ind_subj,subj)/2);
        kerL(ind_subj,subj)=kerL(ind_subj,subj)/sum(kerL(ind_subj,subj));
        for j1=1:nSubj
            Dhat(:,:,subj)=Dhat(:,:,subj)+kerL(j1,subj)*db_dcompRotResidIR(:,:,j1).';
        end
        hEhat(:,:,subj)=Dhat(:,:,subj)*invVhat;
    end
end

%%% wEhat
hEhatRes=zeros(dim,nSubj);
S=zeros(dim,dim);
for subj=1:nSubj
    hEhatRes(:,subj)=hEhat(:,:,subj)*compRotResidIR(:,subj);
    S=S+hEhatRes(:,subj)*(hEhatRes(:,subj).');
end
S=S/nSubj;
invS=inv(S);
wEhat=invS;

SS=cov(hEhatRes.');
invSS=inv(SS);
wEhat2=invSS;

% Notations as in the paper
save('wks14_SetMask_20140601GAD_ADSt1_variables','Dhat','hEhat','wEhat','hEhatRes','compRotResidIR','d_db_compRotResidIR');

meanAux=mean(hEhatRes,2);

SA=zeros(dim,dim);
for subj=1:nSubj
    SA=SA+(hEhatRes(:,subj)-meanAux)*((hEhatRes(:,subj)-meanAux).');
end
SA=SA/(nSubj-1);
