%%% Run 
%%% 1. f001_setData.m,
%%% 2. f002_mainStage1.m,
%%% 3. f003CF_covMatStage1.m,
%%% 4. f004aetMask_and_Kernel.m

% Stage 2 One-step Raphson-Newton
Bvec=mean(hEhatRes,2);
hEhat_d_db_Res=zeros(dim,dim,nSubj);
for subj=1:nSubj
    hEhat_d_db_Res(:,:,subj)=hEhat(:,:,subj)*db_dcompRotResidIR(:,:,subj);
end
Amat=mean(hEhat_d_db_Res,3);
bEstE_NR=bEstI.'-Amat\Bvec; % that's the estimate of beta from Stage 2;

bs=[m1_bestx; m2_bestx; m3_bestx; m4_bestx;...
    m5_bestx; m6_bestx; m7_bestx; m8_bestx; m9_bestx; resultsBeta(9,:); bEstE_NR.']; 

[nn,dim]=size(bs);    

betaNames=cell(nn,1);
betaNames{1}='m1_bestx'; 
betaNames{2}='m2_bestx'; 
betaNames{3}='m3_bestx'; 
betaNames{4}='m4_bestx'; 
betaNames{5}='m50_bestx'; 
betaNames{6}='m6_bestx'; 
betaNames{7}='m7_bestx'; 
betaNames{8}='m8_bestx'; 
betaNames{9}='m9_bestx'; 

% m9_bestx is the 1st stage estimator
betaNames{nn-1}='m9_bestx_St1';
betaNames{nn}='bEstE_NR';

covE=zeros(dim,dim,nn);
covEdir=zeros(dim,dim,nn);
for i=11:11  %%1:nn
    [varCovE,varCovEdir]=varcovMatE(bs(i,:),Z,X,z0,ZbC,hEhat,wEhat,costcall,costflag);
    covE(:,:,i)=varCovE;
    covEdir(:,:,i)=varCovEdir;
end

sumVarsE=zeros(nn,1);
corrE=zeros(dim,dim,nn);
for i=1:nn
    i
    aux=diag(covE(:,:,i));
    sumVarsE(i)=sum(aux);
    aux=diag(1./sqrt(aux));
    corrE(:,:,i)=aux*covE(:,:,i)*aux;
end

covE_orig=covE;
SigmaI_orig=SigmaI;
save('wks99_Final20140310GAD_ADSt2__betaE_covaMatrices_variables','bs',...
    'mBestvalues','covE','covEdir','bEstE_RN','covE_orig','SigmaI_orig');

Zmax=ceil(max(covE(:))/0.5)*0.5;
Zmin=floor(min(covE(:))/0.5)*0.5;

for i=1:nn
    i
    figure(i);
    surf([1:dim],[1:dim],covE(:,:,i));
    %axis([0 dim 0 dim Zmin Zmax]);
    title(strcat('Covariance Matrix of \beta_E',num2str(i)));
end


% Hypotheses testing
aux=zeros(dM,dM);
Cintercept=[eye(dM) aux aux aux aux];
Cgender=[aux eye(dM) aux aux aux];
Cage=[aux aux eye(dM) aux aux];
Cdiagnosis=[aux aux aux eye(dM) aux];
CinterAD=[aux aux aux aux eye(dM)];

bE=bEstE_NR(:);
SigmaE=covEEE2;
SIGintercept=Cintercept*SigmaE*(Cintercept.');
SIGgender=Cgender*SigmaE*(Cgender.');
SIGage=Cage*SigmaE*(Cage.');
SIGdiagnosis=Cdiagnosis*SigmaE*(Cdiagnosis.');
SIGinterAD=CinterAD*SigmaE*(CinterAD.');

Wintercept=(Cintercept*bE).'*inv(SIGintercept)*(Cintercept*bE);
Wgender=(Cgender*bE).'*inv(SIGgender)*(Cgender*bE)/1.05;
Wage=(Cage*bE).'*inv(SIGage)*(Cage*bE);
Wdiagnosis=(Cdiagnosis*bE).'*inv(SIGdiagnosis)*(Cdiagnosis*bE);
WinterAD=(CinterAD*bE).'*inv(SIGinterAD)*(CinterAD*bE);

p_intercept=1-chi2cdf(Wintercept,dM)
p_gender=1-chi2cdf(Wgender,dM)
p_age=1-chi2cdf(Wage,dM)
p_diagnosis=1-chi2cdf(Wdiagnosis,dM)
p_interAD=1-chi2cdf(WinterAD,dM)


table_sumVarsE=[cum_nIters sumVarsE(1:9)];
table_sumVarsE_asdataset=dataset({table_sumVarsE 'NumberIterations' 'SumOfVariances'});
table_sumVarsE_asdataset


save('wks99_Final20140308GAD_ADSt2');

covE_orig=covE;
SigmaI_orig=SigmaI;

covE11=covE(:,:,11)/nSubj;
SigmaI1=SigmaI;
dSigmaI1=diag(SigmaI1);
dcovE9=diag(covE(:,:,9));
dcovE11=diag(covE11);

% Create Figures
h01=figure(1);
plot(bEstI,'b','LineWidth',1);
hold on;
plot(bEstE_NR,'r:','LineWidth',1);
title({'Model: intercept, gender, age, diagnosis, and age*diagnosis','\beta_I and \beta_E'});
legend('\beta_I - stage 1','\beta_E - stage 2 (NR)','Location','SouthEast');
xlabel('components (1:480)');
ylabel('\beta');
plot([96, 96],[-2*10^(-3), 1*10^(-3)],'k')
plot([192, 192],[-2*10^(-3), 1*10^(-3)],'k')
plot([288, 288],[-2*10^(-3), 1*10^(-3)],'k')
plot([384, 384],[-2*10^(-3), 1*10^(-3)],'k')
plot([480, 480],[-2*10^(-3), 1*10^(-3)],'k')
saveas(h01,'figRN01_BetaIBetaE.png');
saveas(h01,'figRN01_BetaIBetaE.fig');


h02=figure(2);
plot(bEstE_NR,'r','LineWidth',1);
hold on;
plot(bEstI,'b:','LineWidth',2);
title({'Model: intercept, gender, age, diagnosis, and age*diagnosis','\beta_I and \beta_E'});
legend('\beta_E - stage 2 (NR)','\beta_I - stage 1','Location','SouthEast');
xlabel('components (1:480)');
ylabel('\beta');
plot([96, 96],[-2*10^(-3), 1*10^(-3)],'k')
plot([192, 192],[-2*10^(-3), 1*10^(-3)],'k')
plot([288, 288],[-2*10^(-3), 1*10^(-3)],'k')
plot([384, 384],[-2*10^(-3), 1*10^(-3)],'k')
plot([480, 480],[-2*10^(-3), 1*10^(-3)],'k')
saveas(h02,'figRN02_BetaEBetaI.png');
saveas(h02,'figRN02_BetaEBetaI.fig');

h03=figure(3);
plot([1:2:480],bEstI(1:2:480),'b','LineWidth',1);
hold on;
plot([1:2:480],bEstE_NR(1:2:480),'r:','LineWidth',2);
title({'Model: intercept, gender, age, diagnosis, and age*diagnosis','\beta_I and \beta_E - odd components'});
legend('\beta_I - stage 1','\beta_E - stage 2 (NR)','Location','SouthEast');
xlabel('odd components (1:2:479)');
ylabel('\beta');
plot([96, 96],[-2*10^(-3), 1*10^(-3)],'k')
plot([192, 192],[-2*10^(-3), 1*10^(-3)],'k')
plot([288, 288],[-2*10^(-3), 1*10^(-3)],'k')
plot([384, 384],[-2*10^(-3), 1*10^(-3)],'k')
plot([480, 480],[-2*10^(-3), 1*10^(-3)],'k')
saveas(h03,'figRN03_BetaIBetaE_oddcomps.png');
saveas(h03,'figRN03_BetaIBetaE_oddcomps.fig');

h04=figure(4);
plot([2:2:480],bEstI(2:2:480),'b','LineWidth',1);
hold on;
plot([2:2:480],bEstE_NR(2:2:480),'r:','LineWidth',2);
title({'Model: intercept, gender, age, diagnosis, and age*diagnosis','\beta_I and \beta_E - even components'});
legend('\beta_I - stage 1','\beta_E - stage 2 (NR)','Location','SouthEast');
xlabel('even components (2:2:480)');
ylabel('\beta');
plot([96, 96],[-2*10^(-3), 1*10^(-3)],'k')
plot([192, 192],[-2*10^(-3), 1*10^(-3)],'k')
plot([288, 288],[-2*10^(-3), 1*10^(-3)],'k')
plot([384, 384],[-2*10^(-3), 1*10^(-3)],'k')
plot([480, 480],[-2*10^(-3), 1*10^(-3)],'k')
saveas(h04,'figRN04_BetaIBetaE_evencomps.png');
saveas(h04,'figRN04_BetaIBetaE_evencomps.fig');

h05=figure(5);
hold off;
plot(sqrt(dSigmaI),'b','LineWidth',1);
hold on;
plot(sqrt(dcovE11),'r:','LineWidth',1);
title({'Model: intercept, gender, age, diagnosis, and age*diagnosis','Standard deviatios of \beta_I and \beta_E - all components'});
legend('\beta_I - stage 1','\beta_E - stage 2 (NR)','Location','SouthOutside');
xlabel('components (1:480)');
ylabel('standard deviation');
plot([96, 96],[0, 1.8*10^(-5)],'k')
plot([192, 192],[0, 1.8*10^(-5)],'k')
plot([288, 288],[0, 1.8*10^(-5)],'k')
plot([384, 384],[0, 1.8*10^(-5)],'k')
plot([480, 480],[0, 1.8*10^(-5)],'k')
saveas(h05,'figRN05_stdsBetaIBetaE_allcomps.png');
saveas(h05,'figRN05_stdsBetaIBetaE_allcomps.fig');

h06=figure(6);
hold off;
plot([1:2:480],sqrt(dSigmaI(1:2:480)),'b','LineWidth',1);
hold on;
plot([1:2:480],sqrt(dcovE11(1:2:480)),'r:','LineWidth',2);
title({'Model: intercept, gender, age, diagnosis, and age*diagnosis','Standard deviatios of \beta_I and \beta_E - odd components'});
legend('\beta_I - stage 1','\beta_E - stage 2 (NR)','Location','SouthOutside');
xlabel('odd components (1:2:479)');
ylabel('standard deviation');
plot([96, 96],[0, 1.8*10^(-5)],'k')
plot([192, 192],[0, 1.8*10^(-5)],'k')
plot([288, 288],[0, 1.8*10^(-5)],'k')
plot([384, 384],[0, 1.8*10^(-5)],'k')
plot([480, 480],[0, 1.8*10^(-5)],'k')
saveas(h06,'figRN06_stdsBetaIBetaE_oddcomps.png');
saveas(h06,'figRN06_stdsBetaIBetaE_oddcomps.fig');

h07=figure(7);
hold off;
plot([2:2:480],sqrt(dSigmaI(2:2:480)),'b','LineWidth',1);
hold on;
plot([2:2:480],sqrt(dcovE11(2:2:480)),'r:','LineWidth',2);
title({'Model: intercept, gender, age, diagnosis, and age*diagnosis','Standard deviatios of \beta_I and \beta_E - even components'});
legend('\beta_I - stage 1','\beta_E - stage 2 (NR)','Location','SouthOutside');
xlabel('even components (2:2:480)');
ylabel('standard deviation');
plot([96, 96],[0, 1.8*10^(-5)],'k')
plot([192, 192],[0, 1.8*10^(-5)],'k')
plot([288, 288],[0, 1.8*10^(-5)],'k')
plot([384, 384],[0, 1.8*10^(-5)],'k')
plot([480, 480],[0, 1.8*10^(-5)],'k')
saveas(h07,'figRN07_stdsBetaIBetaE_evencomps.png');
saveas(h07,'figRN07_stdsBetaIBetaE_evencomps.fig');

h101=figure(101);
imagesc(SigmaI);
title('Covariance Matrix of \beta_I - Stage 1');


h102=figure(102);
imagesc(covE(:,:,11));
title('Covariance Matrix of \beta_E - Stage 2');

h103=figure(103);
imagesc(covE(:,:,11) -SigmaI);
title('Difference of Covariance Matrices: Stage 2 - Stage 1');

h104=figure(104);
imagesc((covE(:,:,11) -SigmaI)./SigmaI);
title('Difference of Covariance Matrices: Stage 2 - Stage 1');




imagesc(diag(1./sqrt(diag(SigmaI)))*(covE(:,:,11) -SigmaI)*diag(1./sqrt(diag(SigmaI))));
colorbar
AA=diag(1./sqrt(diag(SigmaI)))*(covE(:,:,11) -SigmaI)*diag(1./sqrt(diag(SigmaI)));
figure
plot(diag(AA))
plot(-diag(AA))
figure
imagesc(diag(1./sqrt(diag(SigmaI)))*(-covE(:,:,11)+SigmaI)*diag(1./sqrt(diag(SigmaI))));
colorbar
hist(-diag(AA))
figure
hist(-diag(AA))
hist(-diag(AA),20)
mean(-diag(AA))
median(-diag(AA))

dAA=diag(AA);
figure
hist(-dAA(385:480))
mean(-dAA(385:480))
median(-dAA(385:480))
  
covE;
SigmaI;
covE_orig=covE;
SigmaI_orig=SigmaI;
covE=covE/nSubj;
SigmaI=SigmaI/nSubj;
dSigmaI=diag(SigmaI);
dcovE9=diag(covE(:,:,9));
dcovE11=diag(covE(:,:,11));
SigmaIbeta=SigmaI(97:480,97:480);
covE11=covE(:,:,11);
covE11beta=covE11(97:480,97:480);
imagesc(diag(1./sqrt(diag(SigmaIbeta)))*(-covE11beta+SigmaIbeta)*diag(1./sqrt(diag(SigmaIbeta))));
colorbar
AAbeta=diag(1./sqrt(diag(SigmaIbeta)))*(-covE11beta +SigmaIbeta)*diag(1./sqrt(diag(SigmaIbeta)));
dAAbeta=diag(AAbeta);
mean(dAAbeta(289:384))
figure
hist(dAAbeta)


figure(100)
subplot(2,2,1)
imagesc(diag(1./sqrt(diag(SigmaIbeta)))*(-covE11beta+SigmaIbeta)*diag(1./sqrt(diag(SigmaIbeta))));
colorbar
title({'Relative reduction in the covariances of \beta_E','with respect to the covariances of \beta_I'},'FontSize',12,'FontWeight','bold')
subplot(2,2,2)
plot(dAAbeta)
title({'Relative reduction in the variances of \beta_E','with respect to the variances of \beta_I'},'FontSize',12,'FontWeight','bold')
subplot(2,2,3)
surf(SigmaIbeta)
title('Estimated covariance matrix of \beta_I','FontSize',12,'FontWeight','bold')
subplot(2,2,4)
surf(covE11beta)
title('Estimated covariance matrix of \beta_E','FontSize',12,'FontWeight','bold')


figure(20)
subplot('Position',[0.1 0.1 0.35 0.35])
subplot(2,2,1)
%subplot('Position',[0.1 0.1,.35,0.35])
imagesc(AAbeta);
colorbar
title({'Relative reduction in the covariances of \beta_E','with respect to the covariances of \beta_I'},'FontSize',12,'FontWeight','bold')
%subplot('Position',[0.1 0.1 0.35 0.35])
subplot(2,2,2)
plot(dAAbeta(1:2:384))
title({'Relative reduction in the variances of \beta_E','with respect to the variances of \beta_I'},'FontSize',12,'FontWeight','bold')
subplot(2,2,3)
imagesc(SigmaIbeta)
colorbar
title('Estimated covariance matrix of \beta_I','FontSize',12,'FontWeight','bold')
subplot(2,2,4)
imagesc(covE11beta)
colorbar
title('Estimated covariance matrix of \beta_E','FontSize',12,'FontWeight','bold')
