function Z=make2DpreshapeC(X)
% Creates a preshape from a set of landmarks on an object
% Input: 
%    X - a k x 2 real matrix of k landmarks on a planar object,
%        each row represents the coordinates of a landmark point in R^2
% Output:
%    Zr - a k x 2 real matrix representing the presape of X
%    Z - a k x 1 complex vector  representing the presape of X.
[nLX,nCX]=size(X);
if nCX ~= 2
    error('X is not a planar shape');
end
zX=X(:,1)+1i*X(:,2);
czX=zX-mean(zX);
Z=czX/norm(czX);
end