function [varCovE,varCovEdir]=varcovMatE_ADNI(bE,Z,X,z0,ZbC,hEhat,Dhat)
%

%  b must be a row-vector;
% hEhat,wEhat are computed based on the first stage estimator.

dim=length(bE);
[nL,nSubj]=size(Z);
cov_num=length(X(1,:));
dimC=nL-2;
dM=2*dimC;

cmuECmat=zeros(nL,nSubj);
db_dcmuECmat=zeros(nL,dim,nSubj);
rotResidECmat=zeros(nL,nSubj);
db_drotResidECmat=zeros(nL,dim,nSubj);
compRotResidEC=zeros(dimC,nSubj);
db_dcompRotResidEC=zeros(dimC,dim,nSubj);

for subj=1:nSubj
    [cmuECmat(:,subj),db_dcmuECmat(:,:,subj)]=db_dCondMean(bE,z0,ZbC,X(subj,:));
    [rotResidECmat(:,subj),db_drotResidECmat(:,:,subj)]=db_drotResid(z0,cmuECmat(:,subj),db_dcmuECmat(:,:,subj),Z(:,subj));
end


compRotResidEC=ZbC'*rotResidECmat;
db_dcompRotResidEC=zeros(dimC,dim,nSubj);


for subj=1:nSubj
    db_dcompRotResidEC(:,:,subj)=ZbC'*db_drotResidECmat(:,:,subj);
end

compRotResidER=zeros(2*dimC,nSubj);
db_dcompRotResidER=zeros(2*dimC,dim,nSubj);
for j=1:dimC
    compRotResidER(2*j-1,:)=real(compRotResidEC(j,:));
    compRotResidER(2*j,:)=imag(compRotResidEC(j,:));
    db_dcompRotResidER(2*j-1,:,:)=real(db_dcompRotResidEC(j,:,:));
    db_dcompRotResidER(2*j,:,:)=imag(db_dcompRotResidEC(j,:,:));
end




hEhatRes=zeros(dim,nSubj);
hEhat_dRes=zeros(dim,dim,nSubj);
meanHdE=zeros(dim,dim);
covHE=zeros(dim,dim);
covHE2=zeros(dim,dim);
for subj=1:nSubj
    hEhatRes(:,subj)=hEhat(:,:,subj)*compRotResidER(:,subj);
    hEhat_dRes(:,:,subj)=hEhat(:,:,subj)*db_dcompRotResidER(:,:,subj);
    covHE2=covHE2+hEhatRes(:,subj)*(hEhatRes(:,subj).');
end

meanHdE=mean(hEhat_dRes,3);
invMeanHdE=meanHdE\eye(dim,dim);

covHE2=covHE2/nSubj;
varCovEdir=invMeanHdE*covHE2*(invMeanHdE.');
varCovEdir=(varCovEdir+varCovEdir.')/2;

covHE=cov(hEhatRes.');
varCovE=invMeanHdE*covHE *(invMeanHdE.');
varCovE=(varCovE+varCovE.')/2;

end


